program datamod
  use sep

  implicit none
  real                             :: pi,ome,ome1,t1,amp,disp
  integer                          :: n1,n2,n3,i1,i2,n2f,perc,j2
	real                             :: d1,d2,d3,o1,o2,o3
  real,dimension(:,:),allocatable  :: datOut
  
  call sep_init()
	call from_par("n1",n1)
	call from_par("n2",n2)
	call from_par("d1",d1)
	call from_par("d2",d2)
	call from_par("o1",o1)
	call from_par("o2",o2)
	call from_par("n3",n3)
	call from_par("d3",d3)
	call from_par("o2",o2)

	
	call to_history("n1",n1)
	call to_history("n2",n2)
	call to_history("d1",d1)
	call to_history("d2",d2)
	call to_history("o1",o1)
	call to_history("o2",o2)
	call to_history("n3",n3)
	call to_history("d3",d3)
	call to_history("o2",o2)
	call to_history("esize",4)

  call from_param("disp",disp,0.)
  call from_par("ome",ome)
  call from_par("perc",perc)
  call from_par("amp",amp)
  call sep_close()

  write(0,*) 'n1=',n1
  write(0,*) 'n2=',n2

  pi=3.14159

  allocate (datOut(n1,n2))

! ground roll style generator frequency

  datOut = 0. 
  ome1   = ome*pi/180
  n2f    = int(n2*perc/100)

  do i2=1,n2f
     if((i2-1)*d2+o2<0.)then
             do i1=1,n1

                t1=i1; datOut(i1,i2) = datOut(i1,i2) + amp*cos(t1*ome1*(1+(t1*disp/n1))+i2*pi/4)
             enddo
     else                
             do i1=1,n1
                t1=i1; datOut(i1,i2) = datOut(i1,i2) + amp*cos(t1*ome1-i2*pi/4)
             enddo
    endif             
  enddo


  call sep_write(datOut)

  deallocate(datOut)
 
  call exit(0)

end program datamod
