module dix_inv_mod

  use adj_mod

  implicit none

  integer,private :: n
contains
  subroutine wt_init(n1)
    integer n1
    n = n1
  end subroutine wt_init

  !------------Weighting function operator---------------
  integer function wt_dix(adj, add, m, d)
    real               :: m(:), d(:)
    logical,intent(in) :: adj, add 
    integer i

    call adjnull(adj,add,m,d)

    do i=1,n,1
       if (adj) then
          !m(i) = m(i) + d(i)/i
          m(i) = m(i) + d(i)    
       else
          !d(i) = d(i) + m(i)/i
          d(i) = d(i) + m(i)
       end if
    end do
    wt_dix = 0
  end function Wt_dix

end module dix_inv_mod
