program main
  use sep
  use triangle2_mod
  implicit none

  real, allocatable     :: infile(:)
  real, allocatable     :: outfile(:)
  real                  :: dx, dy, dz, ox, oy, oz
  integer               :: nx, ny, nz 
  integer               :: wind1,wind2,wind3
  integer               :: ix, iy, iz 
  real                  :: x, y, z 
  real                  :: add
  integer		:: stat
  call initpar()

  if (exist_file("infile"))then
      call from_aux("infile","n1",nz); call from_aux("infile","d1",dz); call from_aux("infile","o1",oz)
      call from_aux("infile","n2",nx); call from_aux("infile","d2",dx); call from_aux("infile","o2",ox) 
      call from_aux("infile","n3",ny); call from_aux("infile","d3",dy); call from_aux("infile","o3",oy)
      allocate(infile(nz*nx*ny)); 
      call sreed("infile", infile, 4*nz*nx*ny)
  else
       call from_history('n1',nz); call from_history('d1',dz);  call from_history('o1',oz); 
       call from_history('n2',nx); call from_history('d2',dx);  call from_history('o2',ox); 
       call from_history('n3',ny); call from_history('d3',dy);  call from_history('o3',oy);    
       allocate(infile(nz*nx*ny)); 
       call sreed("in", infile, 4*nz*nx*ny)
  endif
  allocate(outfile(nz*nx*ny)); 

  call from_param("wind1",wind1,2)
  call from_param("wind2",wind2,2)
  call from_param("wind3",wind3,2)
  
  call triangle2_init(wind1,wind2,nz,nx)
  
  do iy=1,ny
        write(0,*)'iy:',iy
        stat =triangle2_lop (.false.,.false.,infile(1+nx*nz*(iy-1):nx*nz*iy), outfile(1+nx*nz*(iy-1):nx*nz*iy)) 
  end do

  call to_history("n1", nz); call to_history("d1", dz); call to_history("o1", oz)
  call to_history("n2", nx); call to_history("d2", dx); call to_history("o2", ox)
  call to_history("n3", ny); call to_history("d3", dy); call to_history("o3", oy)
  call to_history("label1", 'z'); call to_history("label2", 'x'); call to_history("label3", 'y')
  call to_history("esize", 4); 
  call srite("out", outfile, 4*nz*nx*ny)
end program
