module solver_sep_mod  
! 0 = F m - d
        use cgstep_mod
        use chain0_mod 
        use ddot_mod
        use quantile_mod 
   
        implicit none
        logical, parameter, private     :: T = .true., F = .false.
        logical,            private     :: time
        real    , private               :: scale
        real    ,save                   :: tstart, tfinish, ttot, tinv, telapse, tleft, tnow, told
        integer ,save                   :: tarray(8), tarray1(8), tarray2(8), itniter, itleft
        real    ,save                   :: treshold
        character(len=256),private,save :: report_
        logical,            private     :: report_fil
        contains
!#################################irls-antoine
  subroutine IRLS( oper, solv, x, dat, niter, nfreq, wght, err)
        optional ::        err
        interface; 
                integer function wght( res, w)                  ; real, dimension (:)   :: res, w  ;                                      end function 
                integer function oper( adj, add, x, dat)        ; logical, intent (in)  :: adj, add; real, dimension (:)  :: x, dat      ;end function 
                integer function solv( forget, x, g, rr, gg)    ; logical               :: forget  ;  real, dimension (:) :: x, g, rr, gg;end function
        end interface 
        real, dimension (:), intent (in)  :: dat                ! data
        real, dimension (:), intent (out) :: x                  ! solution
        real, dimension (:), intent (out) :: err                ! error
        integer,             intent (in)  :: niter, nfreq       ! iterations
        real, dimension (size (x))        :: g                  ! gradient
        real, dimension (size (dat))      :: rr, gg, wt         ! res, CG, weight
        integer                           :: i, stat
        logical                           :: forget
        real                              :: f0

        rr = -dat

        x = 0.
        wt = 1.
        forget = T                                      ! initialize

        do i = 1, niter  
                if (forget) then                        !restart
                        rr = - dat
                        stat = oper( F, T, x, rr)       ! rr = Fx - d 
                        stat = wght( rr, wt)            ! compute weighting
                        rr = rr * wt
                end if    
                if (present(err)) then
                        if(i.eq.1) f0 = sum(dprod(rr,rr))
                        err(i) = sum(dprod(rr,rr))/f0
                        write(0,*) 'residual(',i,')=',err(i)
                endif
                stat = oper( T, F, g, wt*rr)            ! g  = F' W' rr
                stat = oper( F, F, g, gg)               ! gg = Fg
                gg = gg * wt      
                stat = solv( forget, x, g, rr, gg)      ! step in x and rr  
                forget = ( mod( i, nfreq) .eq. 0)       ! periodic restart                     
        end do
 end subroutine 
!#################################irls weights    
    subroutine IRLS_init (tr)
      real   :: tr
      treshold = tr
    end subroutine IRLS_init

    function weight_IRLS(res,w) result(stat)
       integer                    ::stat,i
       real, dimension(:)         ::res,w  
        do i=1, size(res)
                w(i) = 1./sqrt(sqrt(1.+res(i)*res(i)/(treshold*treshold)))
        end do
        stat = 0
    end function weight_IRLS
  
    integer function l1 (res, weight)
      real, dimension (:)  :: res, weight
      real                 :: rbar
         rbar = quantile( int( 0.5*size(res)), abs (res))            
         weight = 1. / sqrt( sqrt (1. + (res/rbar)**2))
         l1 = 0
  end function l1 
end module 
